Halide 22.0.0 Halide compiler and libraries

Loading...
Searching...
No Matches
Classes | Public Member Functions | Public Attributes | Static Public Attributes | List of all members
Halide::Internal::IRMatcher::BroadcastOp< A, B > Struct Template Reference

`#include <IRMatch.h>`

## Classes
struct | pattern_tag

## Public Member Functions
template<uint32_t bound>
HALIDE_ALWAYS_INLINE bool | match (const BaseExprNode &e, MatcherState &state) const noexcept
template<uint32_t bound, typename A2 , typename B2 >
HALIDE_ALWAYS_INLINE bool | match (const BroadcastOp< A2, B2 > &op, MatcherState &state) const noexcept
HALIDE_ALWAYS_INLINE Expr | make (MatcherState &state, halide_type_t type_hint) const
template<typename A1 = A>
HALIDE_ALWAYS_INLINE void | make_folded_const (halide_scalar_value_t &val, halide_type_t &ty, MatcherState &state) const noexcept

## Public Attributes
A | a
B | lanes

## Static Public Attributes
static constexpr uint32_t | binds = bindings<A>::mask | bindings<B>::mask
static constexpr IRNodeType | min_node_type = IRNodeType::Broadcast
static constexpr IRNodeType | max_node_type = IRNodeType::Broadcast
static constexpr bool | canonical = A::canonical && B::canonical
static constexpr bool | foldable = false

## Detailed Description

template<typename A, typename B>
struct Halide::Internal::IRMatcher::BroadcastOp< A, B >

Definition at line 1797 of file IRMatch.h.

## Member Function Documentation

## ◆ match() [1/2]

template<typename A , typename B >
template<uint32_t bound>

HALIDE_ALWAYS_INLINE bool Halide::Internal::IRMatcher::BroadcastOp< A, B >::match | ( | const BaseExprNode & | e,
|  | MatcherState & | state
| ) |  | const
| inline noexcept

Definition at line 1810 of file IRMatch.h.

References Halide::Internal::Broadcast::_node_type, Halide::Internal::IRMatcher::BroadcastOp< A, B >::a, Halide::Internal::IRMatcher::cast(), Halide::Expr::get(), Halide::Internal::Broadcast::lanes, Halide::Internal::IRMatcher::BroadcastOp< A, B >::lanes, and Halide::Internal::Broadcast::value.

Referenced by Halide::Internal::IRMatcher::BroadcastOp< A, B >::match().

## ◆ match() [2/2]

template<typename A , typename B >
template<uint32_t bound, typename A2 , typename B2 >

HALIDE_ALWAYS_INLINE bool Halide::Internal::IRMatcher::BroadcastOp< A, B >::match | ( | const BroadcastOp< A2, B2 > & | op,
|  | MatcherState & | state
| ) |  | const
| inline noexcept

Definition at line 1822 of file IRMatch.h.

References Halide::Internal::IRMatcher::BroadcastOp< A, B >::a, Halide::Internal::IRMatcher::cast(), Halide::Internal::IRMatcher::BroadcastOp< A, B >::lanes, Halide::Internal::IRMatcher::BroadcastOp< A, B >::match(), and Halide::Internal::IRMatcher::unwrap().

## ◆ make()

template<typename A , typename B >

HALIDE_ALWAYS_INLINE Expr Halide::Internal::IRMatcher::BroadcastOp< A, B >::make | ( | MatcherState & | state,
|  | halide_type_t | type_hint
| ) |  | const
| inline

Definition at line 1828 of file IRMatch.h.

References Halide::Internal::IRMatcher::BroadcastOp< A, B >::a, Halide::Internal::IRMatcher::cast(), Halide::Internal::IRMatcher::BroadcastOp< A, B >::lanes, and Halide::Internal::Broadcast::make().

## ◆ make_folded_const()

template<typename A , typename B >
template<typename A1 = A>

HALIDE_ALWAYS_INLINE void Halide::Internal::IRMatcher::BroadcastOp< A, B >::make_folded_const | ( | halide_scalar_value_t & | val,
|  | halide_type_t & | ty,
|  | MatcherState & | state
| ) |  | const
| inline noexcept

Definition at line 1845 of file IRMatch.h.

References Halide::Internal::IRMatcher::BroadcastOp< A, B >::a, Halide::Internal::IRMatcher::cast(), Halide::Internal::IRMatcher::BroadcastOp< A, B >::lanes, and Halide::Internal::IRMatcher::MatcherState::special_values_mask.

## Member Data Documentation

## ◆ a

template<typename A , typename B >

A Halide::Internal::IRMatcher::BroadcastOp< A, B >::a

Definition at line 1799 of file IRMatch.h.

Referenced by Halide::Internal::IRMatcher::BroadcastOp< A, B >::make(), Halide::Internal::IRMatcher::BroadcastOp< A, B >::make_folded_const(), Halide::Internal::IRMatcher::BroadcastOp< A, B >::match(), Halide::Internal::IRMatcher::BroadcastOp< A, B >::match(), and Halide::Internal::IRMatcher::operator<<().

## ◆ lanes

template<typename A , typename B >

B Halide::Internal::IRMatcher::BroadcastOp< A, B >::lanes

Definition at line 1800 of file IRMatch.h.

Referenced by Halide::Internal::IRMatcher::BroadcastOp< A, B >::make(), Halide::Internal::IRMatcher::BroadcastOp< A, B >::make_folded_const(), Halide::Internal::IRMatcher::BroadcastOp< A, B >::match(), Halide::Internal::IRMatcher::BroadcastOp< A, B >::match(), and Halide::Internal::IRMatcher::operator<<().

## ◆ binds

template<typename A , typename B >

constexpr uint32_t Halide::Internal::IRMatcher::BroadcastOp< A, B >::binds = bindings<A>::mask | bindings<B>::mask
| static constexpr

Definition at line 1802 of file IRMatch.h.

## ◆ min_node_type

template<typename A , typename B >

constexpr IRNodeType Halide::Internal::IRMatcher::BroadcastOp< A, B >::min_node_type = IRNodeType::Broadcast
| static constexpr

Definition at line 1804 of file IRMatch.h.

## ◆ max_node_type

template<typename A , typename B >

constexpr IRNodeType Halide::Internal::IRMatcher::BroadcastOp< A, B >::max_node_type = IRNodeType::Broadcast
| static constexpr

Definition at line 1805 of file IRMatch.h.

## ◆ canonical

template<typename A , typename B >

constexpr bool Halide::Internal::IRMatcher::BroadcastOp< A, B >::canonical = A::canonical && B::canonical
| static constexpr

Definition at line 1807 of file IRMatch.h.

## ◆ foldable

template<typename A , typename B >

constexpr bool Halide::Internal::IRMatcher::BroadcastOp< A, B >::foldable = false
| static constexpr

Definition at line 1842 of file IRMatch.h.

The documentation for this struct was generated from the following file:

- src/IRMatch.h